package context

import (
	"github.com/go-kratos/kratos/v2/metadata"
	"golang.org/x/net/context"
)

func SetContext(ctx context.Context, key, value string) context.Context {
	ctx = context.WithValue(ctx, key, value)
	return metadata.AppendToClientContext(ctx, key, value)
}

func GetContext(ctx context.Context, key string) string {
	if ctx == nil {
		return ""
	}
	if ctx.Value(key) != nil {
		return ctx.Value(key).(string)
	}
	if md, ok := metadata.FromServerContext(ctx); ok {
		return md.Get(key)
	}
	return ""
}
