package log

import (
	"os"
	"runtime"
	"strconv"
	"strings"
)

const (
	// Skip 递归获取文件次数
	Skip int = 12
)

func File() []string {
	var files []string
	var i = 4
	for {
		var f string
		_, file, line, ok := runtime.Caller(i)
		if !ok {
			return files
		}
		i++
		if strings.Contains(file, "runtime") {
			continue
		}
		if strings.Contains(file, "pkg/log") {
			continue
		}
		ls := strings.Split(file, "/")
		l := len(ls)
		if l <= 3 {
			f = file
		} else {
			f = ls[l-3] + "/" + ls[l-2] + "/" + ls[l-1]
		}
		if line != 0 {
			files = append(files, f+" "+strconv.Itoa(line))
		}
		if i >= Skip {
			return files
		}
	}
}

// Group 获取日志的分组
func Group(str ...string) string {
	if len(str) != 0 && str[0] != "" {
		return str[0]
	}

	return "log-information-record-" + Environment()
}

// Topic 获取日志的topic
func Topic(str ...string) string {
	if len(str) != 0 && str[0] != "" {
		return str[0]
	}

	return "log-information-record-" + Environment()
}

// Environment 当前环境
func Environment() string {
	env := os.Getenv("JM_ENVIRONMENT")
	if env != "" {
		return env
	}
	return "dev"
}
