package log

import (
	"bufio"
	"fmt"
	"os"
	"strings"
	"sync"
	"time"
)

//type path struct {
//	w *bufio.Writer
//}

var (
	mux     sync.Mutex
	w       *bufio.Writer
	logChan chan *LoggerData
)

func to(path string, data *LoggerData) {
	mux.Lock()
	defer mux.Unlock()
	if logChan == nil {
		logChan = make(chan *LoggerData, 10)
	}
	logChan <- data
	if w == nil {
		file, err := os.OpenFile(path, os.O_WRONLY|os.O_CREATE, 0666)
		if err != nil {
			fmt.Println("文件打开失败", err)
			return
		}
		//及时关闭file句柄
		defer file.Close()
		w = bufio.NewWriter(file)
		go func() {
			write()
		}()
	}
}

func write() {
	for {
		select {
		case l := <-logChan:
			w.WriteString(fmt.Sprintf("[%s] [%s] %s \n %s =========================================== \n", l.Level, l.DateTime, l.Message, strings.Join(l.File, "\n")))
		case <-time.After(time.Second * 5):
			fmt.Println("file flush")
			w.Flush()
			return
		}
	}
}
