package request

import (
	"context"
	"encoding/hex"
	lcontext "git.gz.internal.jumaiyx.cn/pkg/log/context"
	"math/rand"
	"time"
)

const (
	ContextReqId = "x-md-global-req-id"
)

func SetId(ctx context.Context, reqId string) context.Context {
	return lcontext.SetContext(ctx, ContextReqId, reqId)

}
func SetReqId(ctx context.Context) context.Context {
	return SetId(ctx, genReqIdMd5())
}

func SetReqReturnId(ctx context.Context) (context.Context, string) {
	id := genReqIdMd5()
	return SetId(ctx, id), id
}

func genReqIdMd5() string {
	rand.Seed(time.Now().UnixNano())
	result := make([]byte, 16/2)
	rand.Read(result)
	return hex.EncodeToString(result)
}

func GetReqId(ctx context.Context) (context.Context, string) {
	reqId := lcontext.GetContext(ctx, ContextReqId)
	if reqId == "" {
		if ctx == nil {
			ctx = context.TODO()
		}
		ctx, reqId = SetReqReturnId(ctx)
	}
	return ctx, reqId
}
